/* Copyright (c) allObjects - See the file https://muet.mit-license.org LICENSE for copying permission. */

// touchRD.js - add doc - ...for calibration and use of its values (C, bC) in .connect() function.

/*
```
var touch = touchMod.connect(C0,C1,C2,C3
      ,function(x,y) {
         console.log((x != undefined) ? "@ "+x+"/"+y : "- untouch");
       } ).listen();
```
 */

var baseC =
  { X: 240
  , Y: 320
  , XL: 0
  , XH: 239
  , YL: 0
  , YH: 319
  , xt: 0.0015
  , yt: 0.0012
  , xc: 0.4960
  , yc: 0.4795
  , xd: 0.00318
  , yd: 0.00251
  , ti: 100
  , xr: 0
  , yr: 0
  , x: 0
  , y: 0
  , t: false
  , l: false
  , w: null
  };

function TouchRD(yp, xp, yn, xn, cb, C, bC) {
  this.xn = xn;
  this.xp = xp;
  this.yn = yn;
  this.yp = yp;
  this.cb = cb;
  for (var bv in bC) this[bv] = bC[bv];
  if (C) { for (var v in C) this[v] = C[v]; }
}

TouchRD.prototype.xy = function(cb, l, _) {
  _ = _ || this;
  pinMode(_.yn,"input_pulldown");
  pinMode(_.yp); _.yp.read();
  pinMode(_.xn); pinMode(_.xp);
  digitalWrite([_.xn,_.xp],2);
  _.xr = (analogRead(_.yp)+analogRead(_.yp))/2;
  pinMode(_.xn,"input_pulldown");
  _.xp.read();
  pinMode(_.yn);
  digitalWrite([_.yn,_.yp],2);
  _.yr = (analogRead(_.xp)+analogRead(_.xp))/2;
  _.yn.read(); _.yn.read(); 
  if ((_.t = (_.xr>=_.xt && _.yr>=_.yt))) {
    _.x = ((_.x = Math.round(_.X/2+(_.xr-_.xc)/_.xd)-1) 
      <_.XL) ? _.XL : (_.x<=_.XH) ? _.x : _.XH;
    _.y = ((_.y = Math.round(_.Y/2+(_.yr-_.yc)/_.yd)-1) 
      <_.YL) ? _.YL : (_.y<=_.YH) ? _.y : _.YH;
    if (!l && cb) { cb(_.x, _.y, _); }
  } else if (!l && cb) { cb(undefined, undefined, _); }
  return _;
};
TouchRD.prototype.trk = function(e, _) {
  _ = _ || this;
  _.w = null;
  if (_.xy(_.cb, false, _).t && _.l) {
    setTimeout(_.trk, _.ti, _, _);
  } else {
    _.listen(_.l, _);
} };
TouchRD.prototype.listen = function(b, _) {
  _ = _ || this;
  _.l = !!((b === undefined) || b);
  if (_.l && !_.w) {
    pinMode(_.xn,"input_pulldown");
    pinMode(_.xp); _.xp.read();
    pinMode(_.yn); pinMode(_.yp);
    digitalWrite([_.yn,_.yp],3);
    _.w = setWatch(_.trk.bind(_), _.xp
                  , {edge:"rising", repeat:false});
  } else {
    _.w = _.w && clearWatch(_.w);
    _.yn.read(); _.yn.read(); 
  } return _;
};
exports =
{ connect: function(yp, xp, yn, xn, cb, C, bC) {
    return new TouchRD(yp, xp, yn, xn, cb, C, bC || baseC); }
};
