// uiExampleSli.js - uiSli - slider - example

// 20190927 - allObjects - variables: ~ / ~

// ----- setup lon and log() (considering emulating _eConsole)
var lon = true // logging is on / off
  , log = function() { if (lon) { var lgr;(lgr=(typeof _eConsole
       =="object")?_eConsole:console).log.apply(lgr,arguments);}};

// ----- pull in ui base and ui element(s)
var ui = require("ui")
      .add(require("uiSli"))
      ;

// ----- define callback(s): log ui element id and value (only)
var cb = function(id, v, _, e, t) { log( "id:",id,"val:",v
        ,(t)?((t.t)?"":"un")+"touch focused":t); }
  , ca = ( (typeof ca === "undefined")
         ? function(id, v, _, e, t) { var s=(t.f|65536).toString(2); // log flags
             log("id:",id,"v:",v,"f:",[s.substr(5,4),s.substr(9,4),s.substr(13,4)].join(" "),t.f); }
         : ca )
  , u; // for space / memory / var saving value of * undefined *

// ----- define UI (in level 0 - built to be saved)


//---------- Slider examples ----------
//
//   0  1     2       3   4   5   6   7   8  9       10  11 
//flgs  clazz id      x   y   w   h  bc  fs  value  cb,  ls (arr of label ([[...],..]))
//      sli                ->x2->y2                     [0] fv tc    x  y  min max s flgs
ui.c( 3,"sli","s1"  , 10,145,220, 26, -3,[4,-5], 0,  cb,   [[ u, u,   u, u, -10, 10,3,24]]);
//
var s2 = // hold on to "s2" slider ui element for direct access app later on.
//   0  1     2       3   4   5   6   7   8  9      10  11 
//flgs  clazz id      x   y   w   h  bc  fs  value  cb,  ls (arr of label ([[...],..]))
//	     sli                ->x2->y2                     [0] fv tc   x  y  min max s flgs
ui.c( 3,"sli","s2"  , 30,175,180, 26, -4,[-4,0],33,  ca, [[12, 6, 70, 6,   0,100,3,168
//                                                         [0][8] format (function)
                                                           ,function(v,_){ // (val, ui)
       var s="", f=_.te.f; return (!(f==0 || f&184)) ? s : ((v<1)?"0":"") // 128+32+16+8
            +(s=Math.round(v*10)+"%").substr(0,s.length-2)+"."+s.substr(-2); } ] // val
//                                                    [>0] fv tc    x  y  label text
                                                         ,[12, 7, -25, 6, "%:0"] // frnt
                                                         ,[12, 7, 182, 6, "100"] // back
                                                         ]);


//----- pull in display w/ width / height and touch screen
var dsp,   dspMod   = require("ILI9341"), dspW=240, dspH=320
  , touch, touchMod = require("XPT2046")
  ;
// ----- run UI
function onInit() {
  SPI2.setup({sck:B13, miso:B14, mosi:B15, baud: 1000000});
                     // spi,  dc, cs, rst, callback
  dsp = dspMod.connect(SPI2, B10, B1,  A4, function() {
    dsp.clear(); A1.set(); // display clear and turn back light on
    // connect ui to dsp and display it
    ui.connect(dsp)
      .w(0,0,dspW-1,dspH-1) // wipe screen (rect) w/ background color
      .d()                  // display all elements
      .di = true;           // set display changes to immediate
    // setup touch screen and connect it to ui
    SPI1.setup({sck:A5, miso:A6, mosi:A7, baud: 2000000});
                           // spi, cs, irq, callback, calc (calibrated)
    touch = touchMod.connect(SPI1, A3,  A2, function(x,y){ ui.evt(x,y);}
        , function(yr, xr, d) {
            return [ Math.round(xr / -121.44          + 259.70685111989) 
                   , Math.round(yr /   88.90357142857 + -19.78130398103)
                   ];
    }).listen();
  });
}
setTimeout(onInit,999); // for dev only, remove before save()
