// uiLCDTouchValidation2.js

// 20190919 - allObjects - variables:  /  / 

// ----- pull in ui base and ui element(s)
var ui = require("ui")
      .add(require("uiBtn"))
      ;

// ----- define callbacks (to log ui element id and value)
var cb = function(id, v) { console.log(id + ": " + v); };

// ----- define UI (in level 0, so it does not use memory for source)
//   0  1     2       3  4     5    6    7   8
// flgs clazz id      x  y     w    h   bc  fc
//      btn                 ->x2 ->y2         
ui.c(3,"btn","b1"  ,  5, 40,  65,  35,  4,   4
//                    9       10  11 
//                    valObj  cb,  l (label array obj)
//                                 fv tc    x  y  label text
                   , "B_1",  cb,  [15, 7,  13, 9, "RED"  ]);
                   
ui.c(3,"btn","b2"  , 70, 40,  65,  35,  5,   6
                   , {v:1},  cb,  [15, 0,   9, 9, "Y-w-B"]);

//----- pull in display and touchscreen
var dsp, dspMod = require("ILI9341")
  , touch, touchMod = require("XPT2046")
  ;
// ----- run UI
function onInit() {
  SPI2.setup({sck:B13, miso:B14, mosi:B15, baud: 1000000});
                     // spi,  dc, cs, rst, callback
  dsp = dspMod.connect(SPI2, B10, B1,  A4, function() {
    dsp.clear(); A1.set(); // display clear and back light on
    // connect ui to dsp and display it
    ui.connect(dsp)
      .w(0,0,239,319)      // wipe screen w/ background color
      .d()                 // display all elements
      .di = true;          // set display changes to immediate
    // setup touchscreen and connect it to ui
    SPI1.setup({sck:A5, miso:A6, mosi:A7, baud: 2000000});
                           // spi, cs, irq, callback, calc (calibrated)
    touch = touchMod.connect(SPI1, A3,  A2, function(x,y){ ui.evt(x,y);}
        }, function(yr, xr, d) {
          return [ Math.round(xr / -121.44          + 259.70685111989) 
                 , Math.round(yr /   88.90357142857 + -19.78130398103)
                 ];
    }).listen();
    if (touch._eRegisterCanvas) { // only in emulation and before listen
        touch._eRegisterCanvas("dspCanvas", 10, 10); }
  });
  if (dsp._eRegisterCanvas) { // only in emulation dev and before drawing
      dsp._eRegisterCanvas("dspCanvas", 240, 320); }
}
setTimeout(function(){onInit();},999); // for dev only, remove save()
