// uiLCDValidation.js

// 20190919 - allObjects - variables:  /  / 

// ----- pull in dispaly and touchscreen
var dsp, dMod = require("ILI9341") /*,
    touch, tMod = require("XPT2046") */;
// ----- pull in ui base and ui element
var ui = require("ui")
      .add(require("uiBtn"))
      ;

// ----- define callbacks (to log ui element id and value)
var cb = function(id,v) { console.log(id + ": " + v); };

// ----- define UI (in level 0, so it does not use memory for source)
//   0  1     2       3  4     5    6    7   8
// flgs clazz id      x  y     w    h   bc  fc
//      btn                 ->x2 ->y2         
ui.c(3,"btn","b1"  ,  5, 40,  65,  35,  4,   4
//                    9       10  11 
//                    valObj  cb,  l (label array obj)
//                                 fv tc    x  y  label text
                   , "B_1",  cb,  [15, 7,  13, 9, "RED"  ]);
                   
ui.c(3,"btn","b2"  , 70, 40,  65,  35,  5,   6
                   , {v:1},  cb,  [15, 0,   9, 9, "Y-w-B"]);
// ----- run UI
function onInit() {
  SPI2.setup({sck:B13, miso:B14, mosi:B15, baud: 1000000});
                   // spi, dc,  cs, rst, callback
  dsp = dMod.connect(SPI2, B10, B1,  A4, function() {
      dsp.clear(); A1.set(); // display clear and back light on
      // connect ui to dsp and display it
      ui.connect(dsp)
        .w(0,0,239,319) // wipe screen w/ background color
        .d() // display all elements
        .di=true; // set display changes to immediate
      // setup touchscreen and connect it to ui
      /* SPI2.setup({sck:B13, miso:B14, mosi:B15, baud: 2000000});
      touch = tMod.connect(
          // spi, cs, irq, callback, calc (calibration calc function)
          SPI2, B10, B1, function(x,y) { ui.evt(x,y);
          }, function(yr, xr, d) {
            return [ Math.round(xr / -121.44          + 259.70685111989) 
                   , Math.round(yr /   88.90357142857 + -19.78130398103)
                   ];
      });
      if (touch._eRegisterCanvas) { // only in emulation and before listen
          touch._eRegisterCanvas("dspCanvas", 10, 10); } */
  });
  if (dsp._eRegisterCanvas) { // only in emulation dev and before drawing
      dsp._eRegisterCanvas("dspCanvas", 240, 320); }
}
onInit(); // development convenience only... not part of final, saved application code.