// uiWithButtonsExample.js

// 20190919 - allObjects - variables:  /  / 

var ui = require("ui")       // getting ui base and control code (default 8 colors)
      .add(require("uiBtn")) // add/mixin btn ui elt support (and remove from cache)
      ;
function cb(id,v) { console.log(id + ": " + v); } // sample callback
// define ui with - for example - 2 buttons b1 and b2
//   0  1     2       3  4     5    6   7   8  9        10  11 
// flgs clazz id      x  y     w    h  bc  fc  valObj   cb, l (label array obj)
//      btn                 ->x2 ->y2                       fv tc    x  y  label text
ui.c(3,"btn","b1"  ,  5, 40,  65,  35,  4,  4, "B_1",   cb, [15, 7,  13, 9, "RED"  ]);
ui.c(3,"btn","b2"  , 70, 40,  65,  35,  5,  6, {v:2},   cb, [15, 0,   9, 9, "Y-w-B"]);
// bc/fc/tc = border/fill/text colors; cb=callback(id, v, ui, e, t). id is button id,
// such as "b1"; v, ui, e, and t provide button, ui, and touch event runtime data.
// colors 1-bit depth coded w/ 0b### ###=rgb (0=black, 7 is white, 4 is red, etc) 

var dsp,   dspMod   = require("ILI9341"); // display module
var touch, touchMod = require("XPT2046"); // (or "ADS7843") touch screen module

function onInit() {
  SPI2.setup({sck:B13, miso:B14, mosi:B15, baud: 1000000}); // SPI2 for display
                     // spi,  dc, cs, rst, callback
  dsp = dspMod.connect(SPI2, B10, B1,  A4, function() {
    dsp.clear(); A1.set(); // clear display and switch backlight on
    ui.connect(dsp)        // connect ui to dsp (Espruino Graphics object)
      .w(0, 0, 240, 320)   // wipe (clear/fill) screen with screen background color
      .d()                 // display all ui elements
      .di = true;          // set to instant display
    SPI1.setup({sck:A5, miso:A6, mosi:A7, baud: 2000000}); // SPI1 for touch control
                           // spi, cs, irq, callback and calibrated touch functions
    touch = touchMod.connect(SPI1, A3,  A2, function(x,y) { // callback
      ui.evt(x,y);
    }, function(yr, xr, d) { // calbrated touch function
      return [ Math.round(xr / -121.44          + 259.70685111989) 
             , Math.round(yr /   88.90357142857 + -19.78130398103)
             ];
    });
    touch.listen();        // not applicable for ADS7843 / Touchscreen modules
  });
} // /onInit()
onInit(); // while developing only (not part of code to save)

